SAnimation = Core.class()

function SAnimation:init(xtiny)
	xtiny.processingSystem(self) -- called once on init and every frames
	self.sndstepgrass = Sound.new("audio/sfx/footstep/Grass02.wav")
	self.channel = self.sndstepgrass:play(0, false, true)
end

function SAnimation:filter(ent) -- tiny function
	return ent.animation
end

function SAnimation:onRemove(ent) -- tiny function
	ent.animation = nil -- free some memory? XXX
end

local checkanim
function SAnimation:process(ent, dt) -- tiny function
	-- luau ternary operator (no end at the end), it's a 1 liner and seems faster?
	checkanim = if ent.animation.anims[ent.animation.curranim] then ent.animation.curranim else g_ANIM_DEFAULT

	ent.animation.animtimer -= dt
	if ent.animation.animtimer < 0 then
		ent.animation.frame += 1
		ent.animation.animtimer = ent.animation.animspeed
		if checkanim == g_ANIM_JUMPUP_L or checkanim == g_ANIM_JUMPDOWN_L or
			checkanim == g_ANIM_JUMPUP_R or checkanim == g_ANIM_JUMPDOWN_R then
			if ent.animation.frame > #ent.animation.anims[checkanim] then
				ent.animation.frame = #ent.animation.anims[checkanim]
			end
		elseif checkanim == g_ANIM_ATTACK1_L or checkanim == g_ANIM_ATTACK1_R or
			checkanim == g_ANIM_ATTACK2_L or checkanim == g_ANIM_ATTACK2_R then
			if ent.animation.frame > #ent.animation.anims[checkanim] then
--				ent.animation.frame = #ent.animation.anims[checkanim]
				ent.animation.frame = 1
				if not ent.isplayer1 then ent.isaction1 = false end
			elseif ent.animation.frame > 8 then
				ent.headhitbox.isactive = false
			elseif ent.animation.frame > 6 then
				ent.headhitbox.isactive = true
				ent.headhitbox.x = (ent.w/2-5)*ent.flip
				ent.headhitbox.y = -24
				ent.headhitbox.w = 8
				ent.headhitbox.h = 16
				-- debug
--				local pixel = Pixel.new(math.random(0xffffff), 0.2, ent.headhitbox.w, ent.headhitbox.h)
--				pixel:setAnchorPoint(0.5, 0.5)
--				pixel:setPosition(ent.x+ent.headhitbox.x, ent.y+ent.headhitbox.y)
--				ent.spritelayer:addChild(pixel)
			end
		elseif checkanim == g_ANIM_ATTACK3_L or checkanim == g_ANIM_ATTACK3_R or
			checkanim == g_ANIM_ATTACK4_L or checkanim == g_ANIM_ATTACK4_R then
			if ent.animation.frame > #ent.animation.anims[checkanim] then
--				ent.animation.frame = #ent.animation.anims[checkanim]
				ent.animation.frame = 1
				if not ent.isplayer1 then ent.isaction3 = false end
			elseif ent.animation.frame > 5 then
				ent.spinehitbox.isactive = false
			elseif ent.animation.frame > 3 then
				ent.spinehitbox.isactive = true
				ent.spinehitbox.x = (ent.w/2-5)*ent.flip
				ent.spinehitbox.y = 24
				ent.spinehitbox.w = 12
				ent.spinehitbox.h = 16
				-- debug
--				local pixel = Pixel.new(math.random(0xffffff), 0.2, ent.spinehitbox.w, ent.spinehitbox.h)
--				pixel:setAnchorPoint(0.5, 0.5)
--				pixel:setPosition(ent.x+ent.spinehitbox.x, ent.y+ent.spinehitbox.y)
--				ent.spritelayer:addChild(pixel)
			end
		elseif checkanim == g_ANIM_JUMP_ATTACK1_L or checkanim == g_ANIM_JUMP_ATTACK1_R then
			ent.isup, ent.isdown = false, false
			if ent.animation.frame >= #ent.animation.anims[checkanim] then
				ent.animation.frame = #ent.animation.anims[checkanim]
				if not ent.isplayer1 then ent.isjumpaction1 = false end
--				ent.isup, ent.isdown = ent.wasup, ent.wasdown
--				ent.wasup, ent.wasdown = ent.isup, ent.isdown
--				print(ent.isup, ent.isdown, ent.wasup, ent.wasdown)
			else
				ent.headhitbox.isactive = true
				ent.headhitbox.x = 16*ent.flip
				ent.headhitbox.y = 0
				ent.headhitbox.w = ent.w
				ent.headhitbox.h = 64
				ent.spinehitbox.isactive = true
--				ent.spinehitbox.x = (ent.w/2-5)*ent.flip
				ent.spinehitbox.x = 0
				ent.spinehitbox.y = -32
				ent.spinehitbox.w = ent.w
				ent.spinehitbox.h = 32
				-- debug head hitbox
--				local pixel = Pixel.new(0xffffff, 0.2, ent.headhitbox.w, ent.headhitbox.h)
--				pixel:setAnchorPoint(0.5, 0.5)
--				pixel:setPosition(ent.x+ent.headhitbox.x, ent.y+ent.headhitbox.y)
--				ent.spritelayer:addChild(pixel)
				-- debug spine hitbox
--				local pixel2 = Pixel.new(0x0, 0.2, ent.spinehitbox.w, ent.spinehitbox.h)
--				pixel2:setAnchorPoint(0.5, 0.5)
--				pixel2:setPosition(ent.x+ent.spinehitbox.x, ent.y+ent.spinehitbox.y)
--				ent.spritelayer:addChild(pixel2)
			end
		else
			if ent.isplayer1 and (
				(ent.animation.curranim == g_ANIM_WALK_L or ent.animation.curranim == g_ANIM_WALK_R) or
				(ent.animation.curranim == g_ANIM_RUN_L or ent.animation.curranim == g_ANIM_RUN_R) ) and
				(ent.animation.frame == 4 or ent.animation.frame == 9) then
				self.channel = self.sndstepgrass:play()
				if self.channel then self.channel:setVolume(0.9) end
			end
			if ent.animation.frame > #ent.animation.anims[checkanim] then
				ent.animation.frame = 1
			end
		end
		ent.animation.bmp:setTextureRegion(ent.animation.anims[checkanim][ent.animation.frame])
	end
end
