SDebugDraw = Core.class()

function SDebugDraw:init(xtiny) -- tiny function
	xtiny.processingSystem(self) -- called once on init and every update
end

function SDebugDraw:filter(ent) -- tiny function
	return ent.body or ent.headhurtbox or ent.spinehurtbox
end

function SDebugDraw:onAdd(ent) -- tiny function
	local actor = Pixel.new(0xff0000, 0.5, ent.w, ent.h)
	actor:setAnchorPoint(0.5, 0.5)
	if ent.isplayer1 then actor:setColor(0x00ff00, 0.5) end
	ent.spritelayer:addChild(actor)
	ent.bodyDraw = actor -- ref
	local actorheadhurtbox = Pixel.new(0x0000ff, 1, ent.headhurtbox.w, ent.headhurtbox.h)
	actorheadhurtbox:setAnchorPoint(0.5, 0.5)
	if ent.isplayer1 then actorheadhurtbox:setColor(0x0000aa, 1) end
	ent.spritelayer:addChild(actorheadhurtbox)
	ent.bodyDrawHeadHurtbox = actorheadhurtbox -- ref
	local actorspinehurtbox = Pixel.new(0x0000ff, 1, ent.spinehurtbox.w, ent.spinehurtbox.h)
	actorspinehurtbox:setAnchorPoint(0.5, 0.5)
	if ent.isplayer1 then actorspinehurtbox:setColor(0x0000aa, 1) end
	ent.spritelayer:addChild(actorspinehurtbox)
	ent.bodyDrawSpineHurtbox = actorspinehurtbox -- ref
end

function SDebugDraw:onRemove(ent) -- tiny function
	ent.spritelayer:removeChild(ent.bodyDraw)
	ent.spritelayer:removeChild(ent.bodyDrawHeadHurtbox)
	ent.spritelayer:removeChild(ent.bodyDrawSpineHurtbox)
end

function SDebugDraw:process(ent, dt) -- tiny function
	ent.bodyDraw:setPosition(ent.x, ent.y)
	ent.bodyDrawHeadHurtbox:setPosition(ent.x+(ent.headhurtbox.x*ent.flip), ent.y+ent.headhurtbox.y)
	ent.bodyDrawSpineHurtbox:setPosition(ent.x+(ent.spinehurtbox.x*ent.flip), ent.y+ent.spinehurtbox.y)
end



