SDynamicBodies = Core.class()

function SDynamicBodies:init(xtiny, xnmes) -- tiny function
	self.tiny = xtiny -- ref so we can remove entities from tiny system
	self.tiny.processingSystem(self) -- called once on init and every update
	self.nmes = xnmes -- a list of nmes we can hurt
end

function SDynamicBodies:filter(ent) -- tiny function
	return ent.isactor and ent.body -- only actors with body component
end

function SDynamicBodies:onAdd(ent) -- tiny function
end

function SDynamicBodies:onRemove(ent) -- tiny function
end

local wasup, wasdown = false, false
local currup, currdown = false, false
function SDynamicBodies:process(ent, dt) -- tiny function
	-- hurt fx
	if ent.washurt and ent.washurt > 0 then
		ent.washurt -= 1
		if ent.washurt <= 20 then
			if ent.hitfx then ent.hitfx:setVisible(false) end
		end
		if ent.washurt <= 0 then
			ent.sprite:setColorTransform(1, 1, 1, 1)
		end
	end
	-- movement
	if ent.isleft and not ent.isright and ent.x > 32 then -- LEFT
		if ent.animation then ent.animation.curranim = g_ANIM_WALK_L end
		ent.flip = -1
		ent.body.vx = -ent.body.speed
	elseif ent.isright and not ent.isleft and ent.x < 1280 - 32 then -- RIGHT
		if ent.animation then ent.animation.curranim = g_ANIM_WALK_R end
		ent.flip = 1
		ent.body.vx = ent.body.speed
	else
		if ent.animation then
			if ent.flip == -1 then ent.animation.curranim = g_ANIM_IDLE_L
			else ent.animation.curranim = g_ANIM_IDLE_R
			end
		end
		ent.body.vx = 0
	end
	if ent.isup and not ent.isdown and ent.y > 32*3 then -- UP
		if ent.animation then ent.animation.curranim = g_ANIM_WALK_L end
--		ent.flip = -1
		ent.body.vy = -ent.body.speed*0.005
	elseif ent.isdown and not ent.isup and ent.y < 320-32 then -- DOWN
		if ent.animation then ent.animation.curranim = g_ANIM_WALK_R end
--		ent.flip = 1
		ent.body.vy = ent.body.speed*0.005
	else
--		if ent.animation then
--			if ent.flip == -1 then ent.animation.curranim = g_ANIM_IDLE_L
--			else ent.animation.curranim = g_ANIM_IDLE_R
--			end
--		end
--		if not ent.body.isgoingup and ent.y >= (ent.positionystart or 0) then
--		if not ent.body.isgoingup and ent.y >= (ent.positionystart or 0) then
		if not ent.body.isgoingup and ent.y >= (ent.positionystart or -1000) then
--		if ent.animation.curranim == g_ANIM_JUMP_ATTACK1_L then
--		if not ent.body.isgoingup then
			ent.body.vy = 0
--			ent.positionystart = -1000
		end
--		g_currgravity = g_gravity
	end
	-- actions (player1)
--	if ent.isplayer1 and ent.isaction1 then
	if ent.isaction1 then -- punch1
--		ent.body.vx = 0
		ent.body.vx /= 10
		ent.body.vy /= 10
--		ent.isaction1 = false
		if ent.animation then
			ent.animation.curranim = g_ANIM_ATTACK2_L
		end
	end
	if ent.isaction3 then -- kick1
--		ent.body.vx = 0
		ent.body.vx /= 5
		ent.body.vy /= 5
--		ent.isaction1 = false
		if ent.animation then
			ent.animation.curranim = g_ANIM_ATTACK3_L
		end
	end
	if ent.isjumpaction1 then -- jumpkick1
--		ent.wasup, ent.wasdown = ent.isup, ent.isdown
		ent.isup, ent.isdown = false, false
--		currup, currdown = ent.isup, ent.isdown
		if ent.body.isgoingup then
			ent.body.vy -= ent.body.jumpspeed
		end
		if ent.y <= ent.positionystart - ent.h*0.45 then
			ent.body.vy += ent.body.jumpspeed
			ent.body.isgoingup = false
		end
		if not ent.body.isgoingup and ent.y >= ent.positionystart then
			ent.body.vy = 0
			ent.y = ent.positionystart
--			ent.positionystart = -1000
			ent.positionystart = nil
			ent.isjumpaction1 = false
--			g_currgravity = g_gravity
			ent.isup, ent.isdown = ent.wasup, ent.wasdown
--			ent.wasup, ent.wasdown = ent.isup, ent.isdown
		end
		if ent.animation then
			ent.animation.curranim = g_ANIM_JUMP_ATTACK1_L
		end
	end
	-- move
	ent.x += ent.body.vx * dt
	ent.y += ent.body.vy * g_currgravity
	ent.sprite:setPosition(ent.x, ent.y)
	if ent.animation then ent.animation.bmp:setScale(ent.sx * ent.flip, ent.sy) end
end
